%{?nodejs_find_provides_and_requires}

%global enable_tests 1

Name:       nodeunit
Version:    0.8.6
Release:    4%{?dist}
Summary:    Easy asynchronous unit testing framework for Node.js
License:    MIT
Group:      System Environment/Libraries
URL:        https://github.com/caolan/nodeunit
Source0:    http://registry.npmjs.org/nodeunit/-/nodeunit-%{version}.tgz
Patch0:     %{name}-0.8.6-Load-system-modules.patch
Patch1:     %{name}-0.8.6-Use-system-assert.js.patch

BuildArch:  noarch
%if 0%{?fedora} >= 19
ExclusiveArch: %{nodejs_arches} noarch
%else
ExclusiveArch: %{ix86} x86_64 %{arm} noarch
%endif

BuildRequires:  nodejs-packaging

%if 0%{?enable_tests}
BuildRequires:  coffee-script
BuildRequires:  expresso
BuildRequires:  npm(async)
BuildRequires:  npm(console.log)
BuildRequires:  npm(ejs)
BuildRequires:  npm(paperboy)
BuildRequires:  npm(should)
BuildRequires:  npm(tap)
%endif

%description
Nodeunit provides an easy asynchronous unit testing framework for Node.js:
 - helps you avoid common pitfalls when testing asynchronous code
 - easy to add test cases with setUp and tearDown functions if you wish
 - flexible reporters for custom output
 - built-in support for HTML and jUnit XML
 - allows the use of mocks and stubs


%prep
%setup -q -n package
# Remove bundled dependencies
rm -rf deps/
rm -f lib/assert.js
# The requires need to be amended to use the unbundled dependencies.
%patch0 -p1
%patch1 -p1

%nodejs_fixdep async '~0.2'
%nodejs_fixdep console.log '~0.1'
%nodejs_fixdep ejs '~1.0'


%build
#nothing to do


%install
mkdir -p %{buildroot}%{nodejs_sitelib}/nodeunit
cp -pr package.json index.js lib/ \
    %{buildroot}%{nodejs_sitelib}/nodeunit
install -p -D -m0755 bin/nodeunit \
    %{buildroot}%{nodejs_sitelib}/nodeunit/bin/nodeunit
mkdir -p %{buildroot}%{_bindir}
ln -sf %{nodejs_sitelib}/nodeunit/bin/nodeunit \
    %{buildroot}%{_bindir}/nodeunit

install -p -D -m0644 man1/nodeunit.1 \
    %{buildroot}%{_mandir}/man1/nodeunit.1

# Put non-javascript arch independent files in _datadir to comply with Node.js
# packaging guidelines.
mkdir -p %{buildroot}%{_datadir}/nodeunit/bin
install -p -D -m0644 bin/nodeunit.json \
    %{buildroot}%{_datadir}/nodeunit/bin/nodeunit.json
cp -pr share/ %{buildroot}%{_datadir}/nodeunit
mkdir -p %{buildroot}%{nodejs_sitelib}/nodeunit/bin
ln -sf %{_datadir}/nodeunit/bin/nodeunit.json \
    %{buildroot}%{nodejs_sitelib}/nodeunit/bin/nodeunit.json
ln -sf %{_datadir}/nodeunit/share \
    %{buildroot}%{nodejs_sitelib}/nodeunit/share


%nodejs_symlink_deps


%if 0%{?enable_tests}
%check
%nodejs_symlink_deps --check
# Fails in Koji
rm -f test/test-httputil.js
%__nodejs ./bin/nodeunit test --reporter tap
%endif


%files
%doc CONTRIBUTORS.md LICENSE README.md doc/ examples/
%{nodejs_sitelib}/nodeunit
%{_bindir}/nodeunit
%{_datadir}/nodeunit
%{_mandir}/man1/nodeunit.1*


%changelog
* Sat Apr 19 2014 Jamie Nguyen <jamielinux@fedoraproject.org> - 0.8.6-4
- fix version of npm(ejs) dependency

* Sun Mar 02 2014 Jamie Nguyen <jamielinux@fedoraproject.org> - 0.8.6-3
- fix broken symlink

* Mon Feb 24 2014 Jamie Nguyen <jamielinux@fedoraproject.org> - 0.8.6-2
- disable test/test-httputil.js as it fails in Koji

* Sun Feb 23 2014 Jamie Nguyen <jamielinux@fedoraproject.org> - 0.8.6-1
- update to upstream release 0.8.6
- remove lib/assert.js

* Sun Feb 23 2014 Jamie Nguyen <jamielinux@fedoraproject.org> - 0.8.1-3
- fix summary and description
- use patch instead of sed

* Sun Feb 23 2014 Jamie Nguyen <jamielinux@fedoraproject.org> - 0.8.1-2
- remove nodejs-json2 dependency as it is not needed either for runtime or
  for the unit tests

* Wed Aug 28 2013 Jamie Nguyen <jamielinux@fedoraproject.org> - 0.8.1-1
- update to upstream release 0.8.1
- remove patch that has been upstreamed
- put non-javascript arch independent files in _datadir to comply with Node.js
  packaging guidelines

* Wed May 29 2013 Jamie Nguyen <jamielinux@fedoraproject.org> - 0.8.0-1
- update to upstream release 0.8.0

* Sun Feb 17 2013 Jamie Nguyen <jamielinux@fedoraproject.org> - 0.7.4-1
- initial package
